# Copyright (C) 2001-2003 The Written Word, Inc.
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2, or (at your option)
# any later version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
# General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software Foundation,
# Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
#
# $Id$

import os
import re

# parent directory holding configuration file
config_dir = '/etc/opt/TWWfsw'

def get_common_base (systype, install_base, pkgname):
  common_base = None

  # replace [-.] with _ because we use to have COMMON_BASE prepended
  # to the system type with these substitutions
  systype_ = re.sub ('[-.]', '_', systype)

  # override default common_base value
  for config in [ install_base + '/etc/tww-inst-configs/' + pkgname,
  install_base + '/etc/tww-inst-configs/default',
  install_base + '/etc/tww-inst-config',
  config_dir + '/configs/' + pkgname,
  config_dir + '/configs/default' ]:
    if not os.path.exists (config):
      continue

    try:
      fh = open (config, 'r')
    except IOError:
      continue

    while 1:
      entry = fh.readline ().rstrip ()
      if not entry: break

      if entry.startswith ('COMMON_BASE='):
        common_base = re.sub ('^COMMON_BASE=(.*)', '\\1', entry)
        break
      elif entry.startswith ('COMMON_BASE' + systype + '='):
        common_base = re.sub ('^COMMON_BASE' + systype + '=(.*)',
                              '\\1', entry)
        break
      elif entry.startswith ('COMMON_BASE' + systype_ + '='):
        common_base = re.sub ('^COMMON_BASE' + systype_ + '=(.*)',
                              '\\1', entry)
        break

    fh.close ()
  else:
    if not common_base:
      common_base = install_base + '/'

  return common_base
