# Copyright (C) 2002-2003, 2009 The Written Word, Inc.
# Copyright (C) 2000-2001 The Written Word, LLC
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2, or (at your option)
# any later version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
# General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software Foundation,
# Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
#
# $Id$

import os
import re
import sys
import types
import urllib2

from urlparse import urljoin, urlparse
from depot import Depot

class file (Depot):
  def __init__ (self, var, dep, sub_depot):
    Depot.__init__ (self, dep)

    if not isinstance (dep, basestring):
      url = dep.url
      self.var = dep.var
    else:
      url = dep
      self.var = var

    self.local_path = urlparse (url).path

    # add to existing depot path
    if not isinstance (dep, basestring):
      self.local_path = os.path.join (dep.local_path, sub_depot)
      self.pkg_url = urljoin (dep.pkg_url, sub_depot)
    else:
      if var and var['dist']:
        self.local_path = os.path.join (self.local_path, var['dist'])
        self.pkg_url = urljoin (self.pkg_url, var['dist'])

  # if file exists
  def exists (self, path):
    return os.path.exists (os.path.join (self.local_path, path))

  def get (self, prog_name, prog_ver, callback):
    pass

  # if depot is on a remote server
  def is_remote (self):
    return 0

  def local_uptodate (self, file):
    return 1

  def open (self, path, mode):
    return open (os.path.join (self.local_path, path))

  # handle proxy and authentication
  def urlopen (self, url):
    return urllib2.urlopen (url)
