#!/opt/fsw/pkgutils16/lib/aux/python/bin/python
#
# Copyright (C) 2015 The Written Word, Inc.
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2, or (at your option)
# any later version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
# General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software Foundation,
# Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
#
# Status of packages during installation (failure, success, etc.)
#
# $Id$

class InstalledInstances:
  def __init__ (self):
    self.entries = {}

  def __getitem__ (self, key):
    pkgname = key[0]
    pkg_ver = key[1]
    pkg_rev = key[2]

    if not self.entries.has_key (pkgname):
      return None

    for entry in self.entries[pkgname]:
      if entry.pkg_ver == pkg_ver and entry.pkg_rev == pkg_rev:
        return entry.result

    raise None

  def __iter__ (self):
    self._pkgname = None

    self._iter_pkgnames = self.entries.iterkeys ()
    self._iter_pkgnames_index = 0
    self._iter_entries = 0

    return iter (self.next, None)

  def __setitem__ (self, key, value):
    pkgname = key[0]
    pkg_ver = key[1]
    pkg_rev = key[2]

    if not self.entries.has_key (pkgname):
      self.entries[pkgname] = []
      self.entries[pkgname].append (InstalledInstance (pkg_ver,
                                                      pkg_rev, value))
    else:
      for entry in self.entries[pkgname]:
        if entry.pkg_ver == pkg_ver and \
        entry.pkg_rev == pkg_rev:
          entry.result = value
          break
      else:
        self.entries[pkgname].append (InstalledInstance (pkg_ver,
                                                        pkg_rev, value))

  def has_key (self, key):
    pkgname = key[0]
    pkg_ver = key[1]
    pkg_rev = key[2]

    if self.entries.has_key (pkgname):
      for entry in self.entries[pkgname]:
        if entry.pkg_ver == pkg_ver and \
        entry.pkg_rev == pkg_rev:
          return True

    return False

  def next (self):
    if len (self.entries) == 0:
      return None

    if not self._iter_entries:
      self._pkgname = self._iter_pkgnames.next ()
      self._iter_entries = iter (self.entries[self._pkgname])

    try:
      return self._iter_entries.next ()
    except StopIteration:
      try:
        self._pkgname = self._iter_pkgnames.next ()
      except StopIteration:
        return None

      self._iter_entries = iter (self.entries[self._pkgname])
      return self._iter_entries.next ()

class InstalledInstance:
  def __init__ (self, pkg_ver, pkg_rev, result):
    self.pkg_ver = pkg_ver
    self.pkg_rev = pkg_rev
    self.result = result		# result of mirror attempt
