# Copyright (C) 2001-2003, 2006, 2015, 2019 The Written Word, Inc.
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2, or (at your option)
# any later version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
# General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software Foundation,
# Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
#
# $Id$

from version import Version

class PkgCacheEntry:
  def __init__ (self, name, version, revision):
    self.pkgname = name
    self.subpkg = None
    self.version = Version (version)
    self.revision = Version (revision)

class PkgCache:
  def __init__ (self, pkgname_prefix, cache):
    self.cache = cache
    self.entries = []				# all entries
    self.neg_entries = []			# all entries
    self.pkgname_prefix = pkgname_prefix
    self.root = None				# alternate root

  # if package name exists in entries
  def has_pkgname (self, pkgname):
    for entry in self.entries:
      if entry.pkgname == pkgname:
        return True

    return False

  # return entry
  def get (self, pkgname):
    for entry in self.entries:
      if entry.pkgname == pkgname:
        return entry

    return None

  # entry version
  def get_version (self, pkgname):
    for entry in self.entries:
      if entry.pkgname == pkgname:
        return entry.version
