# Copyright (C) 2001-2002, 2004 The Written Word, Inc.
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2, or (at your option)
# any later version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
# General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software Foundation,
# Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
#
# $Id$

import os

# exceptions
class PkgconfigError (Exception):
  """Base class for all exceptions"""

  def __init__ (self, arg = None):
    self.msg = arg

  def __str__ (self):
    return self.msg

class PkgconfigProgNotFound (PkgconfigError):
  """package manager not found"""

  def __init__ (self, prog, config_var):
    self.msg = 'Could not find "' + prog + '" in the search path. \
Either rerun and add the path where "' + prog + '" is located to \
$PATH or set the ' + config_var + ' variable in the config file.'


def get_common_dirs (install_dir, package, pkgname):
  common_dirs = []
  dirs = []

  subpkg_type = package.get_subpkg_type (pkgname)

  if subpkg_type == 'man':
    dirs = ['info', 'man']
  elif subpkg_type == 'packages':
    dirs = ['bin', 'sbin', 'info', 'man']
  elif subpkg_type == 'runtime':
    dirs = ['bin', 'sbin']

  for dir in dirs:
    if os.path.isdir (os.path.join (install_dir, dir)):
      common_dirs.append (dir)
                              
  return common_dirs          

def config (package, pkgmgr, systype, installed_packages, output):
  exec 'import pkgconfig.%s' % (package.pkg_type)
  exec 'pkgconfig.%s.config (package, pkgmgr, systype, \
                             installed_packages, output)' % package.pkg_type

def unconfig (package, pkgmgr, systype, installed_packages, output):
  exec 'import pkgconfig.%s' % (package.pkg_type)
  exec 'pkgconfig.%s.unconfig (package, pkgmgr, systype, \
                               installed_packages, output)' % package.pkg_type
