# Copyright (C) 2001-2004, 2006, 2011 The Written Word, Inc.
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2, or (at your option)
# any later version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
# General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software Foundation,
# Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
#
# $Id$

import os
import re
import string
import sys

import pkgconfig

# execute post-install script
def config (package, pkgmgr, systype, pkgnames, output):
  args = ''

  if pkgmgr.args: args += string.join (pkgmgr.args, ' ') + ' '

  for pkgname in pkgnames:
    subpkg_type = package.get_subpkg_type (pkgname)
    if not subpkg_type in ['libruntime', 'man', 'packages', 'runtime']:
      continue

    apply (output, ['msg', 'installing links for ' + pkgname +
                    ' by running:\n'])
    apply (output, ['msg', '$ swconfig ' + args + pkgname + '\n', 2])

    # execute post-install script
    os.system ('swconfig ' + args + pkgname)

# execute pre-remove script
def unconfig (package, pkgmgr, systype, pkgnames, output):
  args = ''

  if pkgmgr.args: args += string.join (pkgmgr.args, ' ') + ' '

  for pkgname in pkgnames:
    subpkg_type = package.get_subpkg_type (pkgname)
    if not subpkg_type in ['libruntime', 'man', 'packages', 'runtime']:
      continue

    apply (output, ['msg', 'removing links for ' + pkgname +
                    ' by running:\n'])
    apply (output, ['msg', '$ swconfig -u ' + args + pkgname + '\n', 2])

    # execute pre-remove script
    os.system ('swconfig -u ' + args + pkgname)
