# Copyright (C) 2001-2003, 2006, 2010 The Written Word, Inc.
# Copyright (C) 2000-2001 The Written Word, LLC
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2, or (at your option)
# any later version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
# General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software Foundation,
# Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
#
# $Id$

import os
import sys

from pkginst.archive import Archive
from pkginst.archive.cpio import ArchiveGcpio

class ArchiveAr (Archive):
  def exists (self, member):
    if os.system ('ar t ' + self.path + ' ' + member + ' >/dev/null 2>&1'):
      return 0
    else:
      return 1

  def extract (self, member):
    # extract to package directory
    pwd = os.getcwd ()
    os.chdir (self.pkgdir)

    if not os.path.exists (member):
      if os.system ('ar x ' + self.path + ' ' + member):
        os.chdir (pwd)
        return 0

    os.chdir (pwd)
    return 1

  def unpack_payload (self, local_depot_is_temporary, local_depot):
    archive = ArchiveGcpio (self.path, self.pkgdir)
    archive.unpack_payload (local_depot_is_temporary, local_depot)

  def verify_payload (self):
    archive = ArchiveGcpio (self.path, self.pkgdir)
    archive.verify_payload ()
