# Copyright (C) 2001-2003, 2006 The Written Word, Inc.
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2, or (at your option)
# any later version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
# General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software Foundation,
# Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
#
# $Id$

import os
import re
import sys

from basedir import get_common_base

# exceptions
class PkglinksError (Exception):
  """Base class for all exceptions"""

  def __init__ (self, arg = None):
    self.msg = arg

  def __str__ (self):
    return self.msg

class PkglinksProgNotFound (PkglinksError):
  """package manager not found"""

  def __init__ (self, prog, config_var):
    self.msg = 'Could not find "' + prog + '" in the search path. \
Either rerun and add the path where "' + prog + '" is located to \
$PATH or set the ' + config_var + ' variable in the config file.'


class Pkglinks:
  def __init__ (self, package, pkgmgr, systype, pkgname):
    self.links = []
    self.pkg_type = package.pkg_type
    self.common_base = get_common_base (systype, package.install_base,
                                        pkgname)
    self.install_name = package.pkgdb_entry_ver.install_name
    self.pkgname = pkgname
    self.root = pkgmgr.root
    self.npkg = {}
    self.npkg['db'] = pkgmgr.npkg_db
    self.npkg['arch'] = pkgmgr.npkg_arch

    # if COMMON_BASE=none in config file
    if self.common_base == 'none':
      return

def init (package, pkgmgr, systype, pkgname):
  exec 'import pkglinks.%s' % (package.pkg_type)
  exec 'pkglinks = pkglinks.%s.%s (package, pkgmgr, systype, \
                                   pkgname)' % (package.pkg_type,
                                                package.pkg_type)

  return pkglinks
