# Copyright (C) 2001-2003 The Written Word, Inc.
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2, or (at your option)
# any later version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
# General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software Foundation,
# Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
#
# $Id$

import os
import re
import sys

from pkglinks import Pkglinks

class depot (Pkglinks):
  def __init__ (self, package, pkgmgr, systype, pkgname):
    Pkglinks.__init__ (self, package, pkgmgr, systype, pkgname)

    # if COMMON_BASE=none in config file
    if self.common_base == 'none':
      return

    for entry in os.popen ('swlist -a path -a type -a cksum -a link_source ' + \
    self.pkgname, 'r').readlines ():
      if not re.match ('\s+/', entry):
        continue

      link = {}
      link['path'] = re.sub ('^\s+([^\s]+).*', '\\1', entry.rstrip ())

      # what common directory link is for
      if re.match (self.common_base + 'bin/', link['path']) or \
      re.match (self.common_base + 'sbin/', link['path']):
        link['dir'] = 'bin'
      elif re.match (self.common_base + 'man/', link['path']):
        link['dir'] = 'man'
      elif re.match (self.common_base + 'info/', link['path']):
        link['dir'] = 'info'
      else:
        continue

      file_type = re.sub ('^\s+[^\s]+\s+[^\s]+ (.).*', '\\1', entry.rstrip ())
      if file_type == 'f':
        link['type'] = 'w'
        link['checksum'] = re.sub ('^\s+[^\s]+\s+[^\s]+ .\s+(\d+).*',
                                   '\\1', entry.rstrip ())
      elif file_type == 's':
        link['type'] = 'l'
        link['dest'] = re.sub ('^\s+[^\s]+\s+[^\s]+ .\s+([^\s]+).*', '\\1',
                               entry.rstrip ())
      else:
        continue

      self.links.append (link)
