# Copyright (C) 2001-2003 The Written Word, Inc.
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2, or (at your option)
# any later version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
# General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software Foundation,
# Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
#
# $Id$

import os
import re
import sys

from pkglinks import Pkglinks

class lpp (Pkglinks):
  def __init__ (self, package, pkgmgr, systype, pkgname):
    Pkglinks.__init__ (self, package, pkgmgr, systype, pkgname)

    # if COMMON_BASE=none in config file
    if self.common_base == 'none':
      return

    if package.get_subpkg_type (pkgname) == 'packages':
      install_name = self.install_name + 'p'
    else:
      install_name = self.install_name
    install_path = package.get_install_path (install_name)

    links_file = os.path.join (self.root + package.install_base,
                               install_path, 'tww-inst/links')
    try:
      fh = open (links_file, 'r')
    except IOError:
      return None
    while 1:
      entry = fh.readline ().rstrip ()
      if not entry: break

      link = {}
      link['dir'] = re.sub ('^. ([^ ]+) .*', '\\1', entry)

      if self.pkgname.endswith ('.pkg'):
        if link['dir'] not in [ 'bin', 'info', 'man', 'sbin' ]:
          continue
      elif self.pkgname.endswith ('.rte'):
        if link['dir'] not in [ 'bin', 'sbin' ]:
          continue
      elif self.pkgname.endswith ('.man'):
        if link['dir'] not in [ 'info', 'man' ]:
          continue
      else:
        continue

      link['type'] = re.sub ('^(.) .*', '\\1', entry)
      link['path'] = re.sub ('^. [^ ]+ ([^ ]+) .*', '\\1', entry)
      if link['type'] == 'l':
        link['dest'] = re.sub ('^. [^ ]+ [^ ]+ ([^ ]+).*', '\\1', entry)
      elif link['type'] == 'w' or link['type'] == 'W':
        link['checksum'] = re.sub ('^. [^ ]+ [^ ]+ ([^ ]+).*', '\\1', entry)

      self.links.append (link)
    fh.close ()
