# Copyright (C) 2001-2003 The Written Word, Inc.
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2, or (at your option)
# any later version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
# General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software Foundation,
# Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
#
# $Id$

import os
import re
import sys

from pkglinks import Pkglinks

class pkgadd (Pkglinks):
  def __init__ (self, package, pkgmgr, systype, pkgname):
    Pkglinks.__init__ (self, package, pkgmgr, systype, pkgname)

    # if COMMON_BASE=none in config file
    if self.common_base == 'none':
      return

    listing = os.popen ('pkgchk -l ' + self.pkgname, 'r').readlines ()
    while listing:
      # Pathname: marks beginning of a file entry
      entry = listing.pop (0).rstrip ()
      if not re.match ('Pathname: /', entry) or \
      re.match ('Pathname: .*info/dir', entry):
        continue

      link = {}
      link['path'] = re.sub ('^[^\s]+ (.*)', '\\1', entry)

      # what common directory link is for
      if re.match ('Pathname: ' + self.common_base + 'bin/', entry) or \
      re.match ('Pathname: ' + self.common_base + 'sbin/', entry):
        link['dir'] = 'bin'
      elif re.match ('Pathname: ' + self.common_base + 'man/', entry):
        link['dir'] = 'man'
      elif re.match ('Pathname: ' + self.common_base + 'info/', entry):
        link['dir'] = 'info'
      else:
        continue

      while listing:
        # empty link marks end of file entry
        entry = listing.pop (0).rstrip ()
        if entry == '':
	  break

        if re.match ('Type: symbolic link', entry):
          link['type'] = 'l'

          while listing:
            entry = listing.pop (0).rstrip ()

            if re.match ('Source of link:', entry):
              link['dest'] = re.sub ('^[^:]+: (.*)', '\\1', entry)
              self.links.append (link)
              break
        elif re.match ('Type: regular file', entry):
          link['type'] = 'w'

          while listing:
            entry = listing.pop (0).rstrip ()

            if re.match ('Expected sum', entry):
              link['checksum'] = re.sub ('^[^:]+: (.*)', '\\1', entry)
              self.links.append (link)
              break
